//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Mayaテクスチャヘッダ
 * @author Junpee
 */

#ifndef MAYA_TEXTURE_H_
#define MAYA_TEXTURE_H_

namespace LampForMaya{

//------------------------------------------------------------------------------
/**
 * Mayaテクスチャ
 */
class MayaTexture{
friend class MayaTextureManager;
public:
	/**
	 * テクスチャのロード
	 * @return 成功すればtrue
	 */
	virtual bool load();

	/**
	 * テクスチャのバインド
	 * @return 成功すればtrue
	 */
	virtual bool bind();

	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual const String& getName() const{ return name_; }

	/**
	 * 幅の取得
	 * @param level ミップマップレベル
	 * @return 幅
	 */
	virtual u_int getWidth(int level = 0) const{
		u_int width = width_ >> level;
		if(width > 0){ return width; }
		return 1;
	}

	/**
	 * 高さの取得
	 * @param level ミップマップレベル
	 * @return 高さ
	 */
	virtual u_int getHeight(int level = 0) const{
		u_int height = height_ >> level;
		if(height > 0){ return height; }
		return 1;
	}

protected:
	/**
	 * コンストラクタ
	 * @param node ノード
	 * @param name 名前
	 */
	MayaTexture(const MObject& node, const String& name);

	/**
	 * デストラクタ
	 */
	virtual ~MayaTexture();

	/**
	 * クリア
	 */
	virtual void clear();

	/**
	 * 最大の2の累乗を求める
	 * @param number 対象となる数
	 * @return 対象の数以下における最大の2の累乗
	 */
	u_int highestPowerOf2(u_int number) const{
		int power = 0;
		while(number > 1){
			power++;
			number >>= 1;
		}
		return power;
	}

private:
	// コピーコンストラクタの隠蔽
	MayaTexture(const MayaTexture& copy);

	// 代入コピーの隠蔽
	void operator =(const MayaTexture& copy);

	// ノード
	MObject node_;
	// 名前
	String name_;
	// テクスチャID
	u_int textureID_;
	// イメージ
	u_char** images_;
	// ミップマップレベル
	int mipmapLevel_;
	// 幅
	u_int width_;
	// 高さ
	u_int height_;
	// リネームコールバックID
	MCallbackId renameCallbackID_;
	// 変更コールバックID
	MCallbackId dirtyCallbackID_;
	// ロード済みフラグ
	bool loaded_;

	// ピクセルあたりバイト数
	static const int bytesPerPixel_ = 4;
};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of MAYA_TEXTURE_H_
//------------------------------------------------------------------------------

